﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Xml.Linq;
using System.IO;

namespace Linq_Ch7
{
    class Program
    {
        static void Main(string[] args)
        {
            #region 创建一个XML文件夹
            string dir = Environment.CurrentDirectory + @"/XML";
            if (!Directory.Exists(dir))
            {
                Directory.CreateDirectory(dir);
            }
            #endregion
            string filePath1 = Environment.CurrentDirectory + @"/XML/XML1.xml";
            #region 创建一个xml
            //创建一个xml文档
            //XDocument doc1 = new XDocument(
            //    //创建一个声明
            //       new XDeclaration("1.0", "utf-8", "yes"),
            //       new XElement("Products",
            //                       new XAttribute("KeyName", "ID"),
            //                       new XAttribute("Identity", "true"),
            //                       new XAttribute("IdentitySeed", "1"),
            //                       new XAttribute("IdentityIncrement", "1"), new XComment("ID是产品表中的主键"),
            //                       new XElement("Product", new XAttribute("ID", "1"),
            //                              new XElement("ID", "1", new XComment("编号"), new XAttribute("type", "int")),
            //                              new XElement("ProductCode", "XYBCNSZYXMN", new XComment("产品编号"), new XAttribute("type", "nvarchar(50)")),
            //                              new XElement("ProductName", "相宜本草男士专用洗面奶", new XComment("产品名称"), new XAttribute("type", "nvarchar(50)")),
            //                              new XElement("ProductUnitPrice", "39.90", new XComment("产品单价"), new XAttribute("type", "decimal(18,2)")),
            //                              new XElement("ProductTypeID", "1", new XComment("产品类型"), new XAttribute("type", "smallint"),
            //                                      new XAttribute("ForeignTable", "ProductType"),
            //                                      new XAttribute("ForeignTableColumn", "ID")
            //                              ),
            //                              new XElement("ProductDescription", "祛痘效果很好", new XComment("产品描述"), new XAttribute("type", "nvarchar(200)"))
            //                )
            //           )
            //    );
            //doc1.Save(filePath1);
            //Console.WriteLine("创建成功");
            #endregion

            #region 读取和查询
            XElement doc2 = XElement.Load(filePath1);
            //Console.WriteLine(doc2.ToString());

            #endregion
            //XDocument doc3 = XDocument.Load(filePath1);
            ////根元素
            //Console.WriteLine("根元素：" + doc3.Root.Name);
            //查找指定名称的元素
            //IEnumerable<XElement> elements1 = from xml in doc2.Elements("Product")
            //                                  where xml.Element("ID").Value == "1"
            //                                  select xml;
            //foreach (XElement xe in elements1)
            //{
            //    Console.WriteLine(xe.Name.LocalName + ":" + xe.Attribute("ID").Value);
            //}


            //3.查找指定属性的元素
            //var elements2 = from xml in doc2.Elements("Product") //获得所有的Product节点
            //                            select new
            //                            {
            //                                编号 = xml.Element("ID").Value,
            //                                产品编号 = xml.Element("ProductCode").Value,
            //                                产品名称 = xml.Element("ProductName").Value,
            //                                产品单价 = xml.Element("ProductUnitPrice").Value,
            //                                产品类型ID = xml.Element("ProductTypeID").Value,
            //                                产品描述 = xml.Element("ProductDescription").Value
            //                            };
            //foreach (var item in elements2)
            //{
            //    Console.WriteLine("产品名称\t"+item.产品名称);
            //}
            //string ProductID="1";
            ////查找指定属性的元素
            //var elements3=from xml in doc2.Elements("Product")
            //                        where xml.Attribute("ID").Value==ProductID
            //                          select new
            //                          {
            //                              编号 = xml.Element("ID").Value,
            //                              产品编号 = xml.Element("ProductCode").Value,
            //                              产品名称 = xml.Element("ProductName").Value,
            //                              产品单价 = xml.Element("ProductUnitPrice").Value,
            //                              产品类型ID = xml.Element("ProductTypeID").Value,
            //                              产品描述 = xml.Element("ProductDescription").Value
            //                          };
            //foreach (var item in elements3)
            //{
            //     Console.WriteLine("ID为"+ProductID+"的产品名称为"+item.产品名称);
            //}









            //4.访问指定元素的所有属性
            //XAttribute firstAttr = doc2.FirstAttribute;
            ////如果第一个不为空，我们继续查找下一个属性
            //if (firstAttr != null) {
            //    Console.WriteLine(firstAttr.Name.LocalName+"："+firstAttr.Value);
            //    XAttribute nextAttr = firstAttr.NextAttribute;
            //    while (nextAttr!=null)
            //    {
            //        Console.WriteLine(nextAttr.Name.LocalName + "：" + nextAttr.Value);
            //        nextAttr = nextAttr.NextAttribute;
            //    }
            //}



            ////5.查找XML中指定名称的元素
            //IEnumerable<XElement> elements4 = from xml in doc2.Descendants("ProductName")
            //                                                           select xml;
            //foreach (var item in elements4)
            //{
            //    Console.WriteLine(item.Name+"："+item.Value);
            //}



            //6.遍历指定节点下的所有对象
            //IEnumerable<XNode> nodes = doc2.Elements("Product").Nodes();
            //foreach (XNode item in nodes)
            //{
            //    Console.WriteLine(item.ToString());
            //}
            //IEnumerable<XComment> cmts = doc2.Elements("Product").Elements("ProductCode").Nodes().OfType<XComment>();
            //foreach (XComment item in cmts)
            //{
            //    Console.WriteLine(item.ToString());
            //}




            //7访问指定节点的父元素
            //string proname = "相宜本草男士专用洗面奶";
            //XElement elements6 = doc2.Descendants("ProductName").Where(itm => itm.Value == (proname)).First();
            ////获得它上面的父元素
            //XElement xe = elements6.Parent;
            //Console.WriteLine("《"+proname+"》对应的编码为"+xe.Element("ProductCode").Value);







            ////8 .排序
            //var xx = from xml in doc2.Elements("Product")
            //         orderby xml.Element("ProductName").Value
            //         select new
            //         {
            //             产品名称=xml.Element("ProductName").Value,
            //             产品单价 = xml.Element("ProductUnitPrice").Value
            //         };
            //foreach (var item in xx)
            //{
            //    Console.WriteLine(item.产品名称+"："+item.产品单价+"元");
            //}



            //9.Ancestors的使用
            //IEnumerable<XElement> elements8 = from xml in doc2.Descendants("ProductName")
            //                                                           select xml;
            //Console.WriteLine("原来的元素");
            //foreach (XElement item in elements8)
            //{
            //    Console.WriteLine(item.Name + "：" + item.Value);
            //}
            ////显示每个元素的父元素
            //Console.WriteLine("现在的父元素");
            //foreach (XElement item in elements8.Ancestors())
            //{
            //     Console.WriteLine(item.Name + "：" + item.Value);
            //}

            ////显示每个元素的所有属性
            //Console.WriteLine("显示每个源元素的属性");
            //foreach (XAttribute item in elements8.Attributes())
            //{
            //    Console.WriteLine(item.Name + "：" + item.Value);
            //}
            ////返回节点集合中每个节点的所有下级节点
            //Console.WriteLine("返回节点集合中每个节点的所有下级节点");
            //foreach (XNode item in elements8.DescendantNodes())
            //{
            //    Console.WriteLine(item.ToString());
            //}








            //3.1
            //XElement newe = new XElement("Product", new XAttribute("ID", "3"),
            //                       new XElement("ID", "3", new XComment("编号"), new XAttribute("type", "int")),
            //                       new XElement("ProductCode", "DBTNT", new XComment("产品编号"), new XAttribute("type", "nvarchar(50)")),
            //                       new XElement("ProductName", "大白兔奶糖", new XComment("产品名称"), new XAttribute("type", "nvarchar(50)")),
            //                       new XElement("ProductUnitPrice", "19.90", new XComment("产品单价"), new XAttribute("type", "decimal(18,2)")),
            //                       new XElement("ProductTypeID", "2", new XComment("产品类型"), new XAttribute("type", "smallint"),
            //                               new XAttribute("ForeignTable", "ProductType"),
            //                               new XAttribute("ForeignTableColumn", "ID")
            //                       ),
            //                       new XElement("ProductDescription", "浓浓的奶香", new XComment("产品描述"), new XAttribute("type", "nvarchar(200)"))
            //         );
            //doc2.Add(newe);
            //doc2.Save(filePath1);
            //Console.WriteLine("添加元素成功！");


            //3.2
            //IEnumerable<XElement> elements9 = from xml in doc2.Elements("Product")
            //                                  where xml.Element("ID").Value == "1"
            //                                  && xml.Element("ProductTypeID").Value == "1"
            //                                  select xml;
            //if (elements9.Count() > 0) {
            //    XElement one = elements9.FirstOrDefault();
            //    one.SetElementValue("ProductName", "第一个产品");
            //    one.SetAttributeValue("ID", "7");
            //}
            //doc2.Save(filePath1);
            //Console.WriteLine("修改元素属性和节点成功！");




            //3.3
            //IEnumerable<XElement> elements10 = from xml in doc2.Elements("Product")
            //                                   where xml.Element("ID").Value == "1"
            //                                   && xml.Element("ProductTypeID").Value == "1"
            //                                   select xml;
            //if (elements10.Count() > 0)
            //{
            //    XElement one = elements10.First();
            //    one.ReplaceAll(
            //        new XAttribute("ID", "1"),
            //        new XElement("ProductName", "相宜本草男士专用洗面奶", new XComment("产品名称"), new XAttribute("type", "nvarchar(50)")),
            //        new XElement("ProductTypeID", "2")
            //        );
            //}
            //doc2.Save(filePath1);
            //Console.WriteLine("替换元素属性和节点成功！");



            //3.5
            //IEnumerable<XElement> elements11 = from ee in doc2.Elements("Product")
            //                                                               select ee;
            //decimal sums = elements11.Sum(i => Convert.ToDecimal(i.Element("ProductUnitPrice").Value));
            //Console.WriteLine("累加后的产品总价为"+sums);




            //IEnumerable<XElement> elements12 = from xml in doc2.Elements("Product")
            //                                   where xml.Attribute("ID").Value == "1"
            //                                   select xml;
            //添加一个属性
            //XAttribute xa = new XAttribute("Increaments", "每次增长的值的大小");
            //if (elements12.Count() > 0) {
            //    XElement xles = elements12.FirstOrDefault();
            //    xles.Add(xa);
            //}
            //doc2.Save(filePath1);
            //Console.WriteLine("添加元素属性成功！");



            //修改
            //if (elements12.Count() > 0)
            //{
            //    XElement xles = elements12.FirstOrDefault();
            //    xles.Attribute("Increaments").Value="每次增长的值的大小已经被我修改了";
            //}
            //doc2.Save(filePath1);
            //Console.WriteLine("修改元素属性成功！");





            //IEnumerable<XElement> elements13 = from xml in doc2.Elements("Product")
            //                                   where xml.Attribute("ID").Value == "1"
            //                                   select xml;
            ////添加注释到xml文件
            //if (elements13.Count() > 0) {
            //    XElement xelements = elements13.FirstOrDefault();
            //    XComment comx = new XComment("这是我测试的注释2013年4月13日1:10:28");
            //    xelements.AddFirst(comx);
            //}
            //doc2.Save(filePath1);
            //Console.WriteLine("添加注释到xml成功！");


            //XDocument doc5 = new XDocument(
            //    new XDeclaration("1.0","utf-8","yes"),
            //    new XElement("People","茗洋芳竹")
            //    );
            //doc5.Save(Environment.CurrentDirectory+@"\XML\xml2.xml");
            //Console.WriteLine("添加了一个声明的XML创建成功");



            //XDocument doc6 = new XDocument(
            //    new XDocumentType("People",null, "People.dtd",null),
            //    new XElement("People", "茗洋芳竹")
            //    );
            //doc6.Save(Environment.CurrentDirectory + @"\XML\xml3.xml");
            //Console.WriteLine("添加了一个文档类型的XML创建成功");




            string xmlStr = "<Product ID=\"2\"><ID type=\"int\">2<!--编号--></ID><ProductCode type=\"nvarchar(50)\">WP7CXSJ<!--产品编号--></ProductCode>"
+"<ProductName type=\"nvarchar(50)\">Windows Phone7 程序设计</ProductName>"
   +" <ProductUnitPrice type=\"decimal(18,2)\">99.00<!--产品单价--></ProductUnitPrice>"
    +"<ProductTypeID type=\"smallint\" ForeignTable=\"ProductType\" ForeignTableColumn=\"ID\">2<!--产品类型--></ProductTypeID>"
    +"<ProductDescription type=\"nvarchar(200)\">wp7开发必备<!--产品描述--></ProductDescription>"
  +"</Product>";
            XElement txe = XElement.Parse(xmlStr);
            txe.Save(Environment.CurrentDirectory+@"\XML\xml5.xml");


            Console.ReadLine();
        }
    }
}
